Attribute VB_Name = "ComplexFactory"
Option Explicit

Public Function Atan2(ByVal y As Double, ByVal x As Double) As Double
Dim theta As Double

    If (Abs(x) < 0.0000001) Then
        If (Abs(y) < 0.0000001) Then
            theta = 0#
        ElseIf (y > 0#) Then
            theta = 1.5707963267949
        Else
            theta = -1.5707963267949
        End If
    Else
        theta = Atn(y / x)

        If (x < 0) Then
            If (y >= 0#) Then
                theta = 3.14159265358979 + theta
            Else
                theta = theta - 3.14159265358979
            End If
        End If
    End If

    Atan2 = theta
End Function


Public Function NewComplex(ByVal new_re As Double, ByVal new_im As Double) As Complex
Dim result As Complex

    Set result = New Complex
    result.Initialize new_re, new_im
    Set NewComplex = result
End Function

